/*
 * FileDisplayException.h
 *  General exception object for NTOF
 *  Created on: Oct 13, 2014
 *      Author: mdonze
 */

#ifndef FILEDISPLAYEXCEPTION_H_
#define FILEDISPLAYEXCEPTION_H_

#include <string>

namespace ntof {
namespace eventDisplay {
/**
 * \class FileDisplayException
 * \brief Represents an exception generated by NTOF
 */
class FileDisplayException : public std::exception
{
public:
    /**
     * \brief Constructs this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     */
    FileDisplayException(const std::string &Msg,
                         const std::string &file,
                         int Line);

    /**
     * \brief Construct this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     */
    FileDisplayException(const char *Msg, const std::string &file, int Line);

    /**
     * \brief Construct this
     * \param Msg Error message
     * \param file Name of the file where the exception is thrown (__FILE__)
     * \param Line Line of code doing the error (__LINE__)
     * \param error Error code
     */
    FileDisplayException(const char *Msg,
                         const std::string &file,
                         int Line,
                         int error);

    /**
     * \brief Empty constructor of the class
     */
    FileDisplayException();

    /**
     * \brief Destructor of the class
     */
    virtual ~FileDisplayException() throw();

    /**
     * \brief Overload of std::exception
     * \return Return the error message
     */
    virtual const char *what() const throw();

    /**
     * \brief Gets the error message
     * \return Return the error message
     */
    const char *getMessage() const throw();

    /**
     * \brief Gets the error code
     * \return
     */
    int getErrorCode() const throw();

    /**
     * \brief Gets the source file
     * \return Source file name
     */
    const std::string getFile() const throw();

    /**
     * \brief Gets the line in source file
     * \return Return the line in source file
     */
    int getLine() const throw();

private:
    mutable std::string what_; //!< Complete error message
    std::string msg;           //!< Error message
    std::string file_;         //!< Source file where the exception is throw
    int line;                  //!< Line of the error
    int errorCode;             //!< Error code
};
} // namespace eventDisplay
} // namespace ntof

#endif /* FILEDISPLAYEXCEPTION_H_ */
